diff -rN -u old-darcsweb/darcsweb.cgi new-darcsweb/darcsweb.cgi
--- old-darcsweb/darcsweb.cgi	2024-06-02 11:27:01.620310410 +0100
+++ new-darcsweb/darcsweb.cgi	2024-06-02 11:27:01.620310410 +0100
@@ -1728,172 +1920,200 @@
 <tr><td>hash</td><td style="font-family: monospace">%(hash)s</td></tr>
 </table>
 </div>
-	""" % {
-		'myreponame': config.myreponame,
-		'author': gen_authorlink(p.author),
-		'local_date': p.local_date_str,
-		'date': p.date_str,
-		'hash': p.hash,
-		'name': escape(p.name),
-	}
-	if p.comment:
-		comment = replace_links(escape(p.comment))
-		c = comment.replace('\n', '<br/>\n')
-		print '<div class="page_body">'
-		print replace_links(escape(p.name)), '<br/><br/>'
-		print c
-		print '</div>'
-
-	changed = p.adds + p.removes + p.modifies.keys() + p.moves.keys() + \
-			p.diradds + p.dirremoves + p.replaces.keys()
-
-	if changed or p.moves:
-		n = len(changed)
-		print '<div class="list_head">%d file(s) changed:</div>' % n
-
-	print '<table cellspacing="0">'
-	changed.sort()
-	alt = True
-	for f in changed:
-		if alt:
-			print '<tr class="dark">'
-		else:
-			print '<tr class="light">'
-		alt = not alt
-
-		show_diff = 1
-		if p.moves.has_key(f):
-			# don't show diffs for moves, they're broken as of
-			# darcs 1.0.3
-			show_diff = 0
-
-		if show_diff:
-			print """
+	"""
+        % {
+            "myreponame": config.myreponame,
+            "author": gen_authorlink(p.author),
+            "local_date": p.local_date_str,
+            "date": p.date_str,
+            "hash": p.hash,
+            "name": xmlescape(p.name),
+        }
+    )
+    if p.comment:
+        comment = replace_links(xmlescape(p.comment))
+        c = comment.replace("\n", "<br/>\n")
+        print('<div class="page_body">')
+        print(replace_links(xmlescape(p.name)), "<br/><br/>")
+        print(c)
+        print("</div>")
+
+    changed = (
+        p.adds
+        + p.removes
+        + list(p.modifies.keys())
+        + list(p.moves.keys())
+        + p.diradds
+        + p.dirremoves
+        + list(p.replaces.keys())
+    )
+
+    if changed or p.moves:
+        n = len(changed)
+        print('<div class="list_head">%d file(s) changed:</div>' % n)
+
+    print('<table cellspacing="0">')
+    changed.sort()
+    alt = True
+    for f in changed:
+        if alt:
+            print('<tr class="dark">')
+        else:
+            print('<tr class="light">')
+        alt = not alt
+
+        show_diff = 1
+        if f in p.moves:
+            # don't show diffs for moves, they're broken as of
+            # darcs 1.0.3
+            show_diff = 0
+
+        if show_diff:
+            print(
+                """
 <td>
   <a class="list" href="%(myreponame)s;a=filediff;h=%(hash)s;f=%(file)s">
     %(fname)s</a>
 </td>
-			""" % {
-				'myreponame': config.myreponame,
-				'hash': p.hash,
-				'file': urllib.quote(f),
-				'fname': escape(f),
-			}
-		else:
-			print "<td>%s</td>" % f
-
-		show_diff = 1
-		if f in p.adds:
-			print '<td><span style="color:#008000">',
-			print '[added]',
-			print '</span></td>'
-		elif f in p.diradds:
-			print '<td><span style="color:#008000">',
-			print '[added dir]',
-			print '</span></td>'
-		elif f in p.removes:
-			print '<td><span style="color:#800000">',
-			print '[removed]',
-			print '</span></td>'
-		elif f in p.dirremoves:
-			print '<td><span style="color:#800000">',
-			print '[removed dir]',
-			print '</span></td>'
-		elif p.replaces.has_key(f):
-			print '<td><span style="color:#800000">',
-			print '[replaced %d tokens]' % p.replaces[f],
-			print '</span></td>'
-		elif p.moves.has_key(f):
-			print '<td><span style="color:#000080">',
-			print '[moved to "%s"]' % p.moves[f]
-			print '</span></td>'
-			show_diff = 0
-		else:
-			print '<td><span style="color:#000080">',
-			if p.modifies[f].has_key('b'):
-				# binary modification
-				print '(binary)'
-			else:
-				print '+%(+)d  -%(-)d' % p.modifies[f],
-			print '</span></td>'
-
-		if show_diff:
-			print """
+			"""
+                % {
+                    "myreponame": config.myreponame,
+                    "hash": p.hash,
+                    "file": urlescape(f),
+                    "fname": xmlescape(f),
+                }
+            )
+        else:
+            print("<td>%s</td>" % f)
+
+        show_diff = 1
+        if f in p.adds:
+            print('<td><span style="color:#008000">', end="")
+            print("[added]", end="")
+            print("</span></td>")
+        elif f in p.diradds:
+            print('<td><span style="color:#008000">', end="")
+            print("[added dir]", end="")
+            print("</span></td>")
+        elif f in p.removes:
+            print('<td><span style="color:#800000">', end="")
+            print("[removed]", end="")
+            print("</span></td>")
+        elif f in p.dirremoves:
+            print('<td><span style="color:#800000">', end="")
+            print("[removed dir]", end="")
+            print("</span></td>")
+        elif p in p.replaces:
+            print('<td><span style="color:#800000">', end="")
+            print("[replaced %d tokens]" % p.replaces[f], end="")
+            print("</span></td>")
+        elif f in p.replaces:
+            print('<td><span style="color:#000080">', end="")
+            print('[moved to "%s"]' % p.moves[f])
+            print("</span></td>")
+            show_diff = 0
+        else:
+            print('<td><span style="color:#000080">', end="")
+            if "b" in p.modifies[f]:
+                # binary modification
+                print("(binary)")
+            else:
+                print("+%(+)d  -%(-)d" % p.modifies[f], end="")
+            print("</span></td>")
+
+        if show_diff:
+            print(
+                """
 <td class="link">
   <a href="%(myreponame)s;a=filediff;h=%(hash)s;f=%(file)s">diff</a> |
   <a href="%(myreponame)s;a=filehistory;f=%(file)s">history</a> |
   <a href="%(myreponame)s;a=annotate_shade;h=%(hash)s;f=%(file)s">annotate</a>
 </td>
-			""" % {
-				'myreponame': config.myreponame,
-				'hash': p.hash,
-				'file': urllib.quote(f)
-			}
-		print '</tr>'
-	print '</table>'
-	print_footer()
+			"""
+                % {
+                    "myreponame": config.myreponame,
+                    "hash": p.hash,
+                    "file": urlescape(f),
+                }
+            )
+        print("</tr>")
+    print("</table>")
+    print_footer()
 
 
 def do_tree(dname):
-	print_header()
-	print_navbar()
+    print_header()
+    print_navbar()
 
-	# the head
-	print """
+    # the head
+    print(
+        """
 <div><a class="title" href="%s;a=tree">Current tree</a></div>
 <div class="page_path"><b>
-	""" % config.myreponame
+	"""
+        % config.myreponame
+    )
 
-	# and the linked, with links
-	parts = dname.split('/')
-	print '/ '
-	sofar = '/'
-	for p in parts:
-		if not p: continue
-		sofar += '/' + p
-		print '<a href="%s;a=tree;f=%s">%s</a> /' % \
-				(config.myreponame, urllib.quote(sofar), p)
+    # and the linked, with links
+    parts = dname.split("/")
+    print("/ ")
+    sofar = "/"
+    for p in parts:
+        if not p:
+            continue
+        sofar += "/" + p
+        print(
+            '<a href="%s;a=tree;f=%s">%s</a> /'
+            % (
+                config.myreponame,
+                urlescape(sofar),
+                p,
+            )
+        )
 
-	print """
+    print(
+        """
   </b></div>
 <div class="page_body">
 <table cellspacing="0">
 	"""
+    )
 
-	path = realpath(dname) + '/'
-
-	alt = True
-	files = os.listdir(path)
-	files.sort()
-
-	# list directories first
-	dlist = []
-	flist = []
-	for f in files:
-		if f == "_darcs":
-			continue
-		realfile = path + f
-		if os.path.isdir(realfile):
-			dlist.append(f)
-		else:
-			flist.append(f)
-	files = dlist + flist
-
-	for f in files:
-		if alt:
-			print '<tr class="dark">'
-		else:
-			print '<tr class="light">'
-		alt = not alt
-		realfile = path + f
-		fullf = filter_file(dname + '/' + f)
-		print '<td style="font-family:monospace">', fperms(realfile),
-		print '</td>'
-		print '<td style="font-family:monospace">', fsize(realfile),
-		print '</td>'
+    path = realpath(dname) + "/"
 
-		if f in dlist:
-			print """
+    alt = True
+    files = os.listdir(path)
+    files.sort()
+
+    # list directories first
+    dlist = []
+    flist = []
+    for f in files:
+        if f == "_darcs":
+            continue
+        realfile = path + f
+        if os.path.isdir(realfile):
+            dlist.append(f)
+        else:
+            flist.append(f)
+    files = dlist + flist
+
+    for f in files:
+        if alt:
+            print('<tr class="dark">')
+        else:
+            print('<tr class="light">')
+        alt = not alt
+        realfile = path + f
+        fullf = filter_file(dname + "/" + f)
+        print('<td style="font-family:monospace">', fperms(realfile), end="")
+        print("</td>")
+        print('<td style="font-family:monospace">', fsize(realfile), end="")
+        print("</td>")
+
+        if f in dlist:
+            print(
+                """
   <td>
     <a class="link" href="%(myrname)s;a=tree;f=%(fullf)s">%(f)s/</a>
   </td>
@@ -1901,132 +2121,152 @@
     <a href="%(myrname)s;a=filehistory;f=%(fullf)s">history</a> |
     <a href="%(myrname)s;a=tree;f=%(fullf)s">tree</a>
   </td>
-			""" % {
-				'myrname': config.myreponame,
-				'f': escape(f),
-				'fullf': urllib.quote(fullf),
-			}
-		else:
-			print """
+			"""
+                % {
+                    "myrname": config.myreponame,
+                    "f": xmlescape(f),
+                    "fullf": urlescape(fullf),
+                }
+            )
+        else:
+            print(
+                """
   <td><a class="list" href="%(myrname)s;a=headblob;f=%(fullf)s">%(f)s</a></td>
   <td class="link">
     <a href="%(myrname)s;a=filehistory;f=%(fullf)s">history</a> |
     <a href="%(myrname)s;a=headblob;f=%(fullf)s">headblob</a> |
     <a href="%(myrname)s;a=annotate_shade;f=%(fullf)s">annotate</a>
   </td>
-			""" % {
-				'myrname': config.myreponame,
-				'f': escape(f),
-				'fullf': urllib.quote(fullf),
-			}
-		print '</tr>'
-	print '</table></div>'
-	print_footer()
+			"""
+                % {
+                    "myrname": config.myreponame,
+                    "f": xmlescape(f),
+                    "fullf": urlescape(fullf),
+                }
+            )
+        print("</tr>")
+    print("</table></div>")
+    print_readme()
+    print_footer()
 
 
 def do_headblob(fname):
-	print_header()
-	print_navbar(f = fname)
-	filepath = os.path.dirname(fname)
-
-	if filepath == '/':
-		print '<div><a class="title" href="%s;a=tree">/</a></div>' % \
-			(config.myreponame)
-	else:
-		print '<div class="title"><b>'
-
-		# and the linked, with links
-		parts = filepath.split('/')
-		print '/ '
-		sofar = '/'
-		for p in parts:
-			if not p: continue
-			sofar += '/' + p
-			print '<a href="%s;a=tree;f=%s">%s</a> /' % \
-					(config.myreponame, sofar, p)
+    print_header()
+    print_navbar(f=fname)
+    filepath = os.path.dirname(fname)
+
+    if filepath == "/":
+        print(
+            '<div><a class="title" href="%s;a=tree">/</a></div>'
+            % (config.myreponame)
+        )
+    else:
+        print('<div class="title"><b>')
+
+        # and the linked, with links
+        parts = filepath.split("/")
+        print("/ ")
+        sofar = "/"
+        for p in parts:
+            if not p:
+                continue
+            sofar += "/" + p
+            print(
+                '<a href="%s;a=tree;f=%s">%s</a> /'
+                % (config.myreponame, sofar, xmlescape(p))
+            )
 
-		print '</b></div>'
+        print("</b></div>")
 
-	print_blob(fname)
-	print_footer()
+    print_blob(fname)
+    print_footer()
 
 
 def do_plainblob(fname):
-	f = open(realpath(fname), 'r')
+    f = open(realpath(fname), "r")
 
-	if isbinary(fname):
-		print_binary_header(os.path.basename(fname))
-		for l in f:
-			sys.stdout.write(l)
-	else:
-		print_plain_header()
-		for l in f:
-			sys.stdout.write(fixu8(l))
+    if isbinary(fname):
+        print_binary_header(os.path.basename(fname))
+        for l in f:
+            sys.stdout.write(l)
+    else:
+        print_plain_header()
+        for l in f:
+            sys.stdout.write((l))
 
 
 def do_annotate(fname, phash, style):
-	print_header()
-	ann = get_annotate(fname, phash)
-	if not ann:
-		print """
+    print_header()
+    ann = get_annotate(fname, phash)
+    if not ann:
+        print(
+            """
 <i>The annotate feature has been disabled</i>
 </div>
 		"""
-		print_footer()
-		return
-	print_navbar(f = fname, h = ann.lastchange_hash)
+        )
+        print_footer()
+        return
+    print_navbar(f=fname, h=ann.lastchange_hash)
 
-	print """
+    print(
+        """
 <div>
   <a class="title" href="%(myreponame)s;a=commit;h=%(hash)s">%(name)s</a>
 </div>
 <div class="page_path"><b>
   Annotate for file %(fname)s
 </b></div>
-	""" % {
-		'myreponame': config.myreponame,
-		'hash': ann.lastchange_hash,
-		'name': escape(ann.lastchange_name),
-		'fname': escape(fname),
-	}
+	"""
+        % {
+            "myreponame": config.myreponame,
+            "hash": ann.lastchange_hash,
+            "name": xmlescape(ann.lastchange_name),
+            "fname": xmlescape(fname),
+        }
+    )
+
+    print_annotate(ann, style)
+    print_footer()
 
-	print_annotate(ann, style)
-	print_footer()
 
 def do_annotate_plain(fname, phash):
-	print_plain_header()
-	ann = get_annotate(fname, phash)
-	for l in ann.lines:
-		sys.stdout.write(l.text)
+    print_plain_header()
+    ann = get_annotate(fname, phash)
+    for l in ann.lines:
+        sys.stdout.write(l.text)
 
 
 def do_shortlog(topi, last=PATCHES_PER_PAGE):
-	print_header()
-	print_navbar()
-	print_shortlog(topi = topi, last = last)
-	print_footer()
+    print_header()
+    print_navbar()
+    print_shortlog(topi=topi, last=last)
+    print_footer()
+
 
 def do_filehistory(topi, f, last=PATCHES_PER_PAGE):
-	print_header()
-	print_navbar(f = fname)
-	print_shortlog(topi = topi, fname = fname, last = last)
-	print_footer()
+    print_header()
+    print_navbar(f=fname)
+    print_shortlog(topi=topi, fname=fname, last=last)
+    print_footer()
+
 
 def do_log(topi, last=PATCHES_PER_PAGE):
-	print_header()
-	print_navbar()
-	print_log(topi = topi, last = last)
-	print_footer()
+    print_header()
+    print_navbar()
+    print_log(topi=topi, last=last)
+    print_footer()
+
 
 def do_atom():
-	print "Content-type: application/atom+xml; charset=utf-8\n"
-	print '<?xml version="1.0" encoding="utf-8"?>'
-	inv = config.repodir + '/_darcs/patches'
-	repo_lastmod = os.stat(inv).st_mtime
-	str_lastmod = time.strftime(iso_datetime,
-			time.localtime(repo_lastmod))
+    print("Content-type: application/atom+xml; charset=utf-8\n")
+    print('<?xml version="1.0" encoding="utf-8"?>')
+    inv = config.repodir + "/_darcs/patches"
+    repo_lastmod = os.stat(inv).st_mtime
+    str_lastmod = time.strftime(iso_datetime, time.localtime(repo_lastmod))
 
-	print """
+    print(
+        """
 <feed xmlns="http://www.w3.org/2005/Atom">
   <title>%(reponame)s darcs repository</title>
   <link rel="alternate" type="text/html" href="%(url)s"/>
@@ -2036,30 +2276,36 @@
   <generator>darcsweb.cgi</generator>
   <updated>%(lastmod)s</updated> 
   <subtitle>%(desc)s</subtitle>
-  	""" % {
-		'reponame': config.reponame,
-		'url': config.myurl + '/' + config.myreponame,
-		'desc': escape(config.repodesc),
-		'lastmod': str_lastmod,
-	}
-
-	ps = get_last_patches(20)
-	for p in ps:
-		title = time.strftime('%d %b %H:%M', time.localtime(p.date))
-		title += ' - ' + p.name
-		pdate = time.strftime(iso_datetime,
-				time.localtime(p.date))
-		link = '%s/%s;a=commit;h=%s' % (config.myurl,
-				config.myreponame, p.hash)
-
-		import email.Utils
-		addr, author = email.Utils.parseaddr(p.author)
-		if not addr:
-			addr = "unknown_email@example.com"
-		if not author:
-			author = addr
+  	"""
+        % {
+            "reponame": config.reponame,
+            "url": config.myurl + "/" + config.myreponame,
+            "desc": xmlescape(config.repodesc),
+            "lastmod": str_lastmod,
+        }
+    )
+
+    ps = get_last_patches(20)
+    for p in ps:
+        title = time.strftime("%d %b %H:%M", time.localtime(p.date))
+        title += " - " + p.name
+        pdate = time.strftime(iso_datetime, time.localtime(p.date))
+        link = "%s/%s;a=commit;h=%s" % (
+            config.myurl,
+            config.myreponame,
+            p.hash,
+        )
+
+        import email.utils
+
+        addr, author = email.utils.parseaddr(p.author)
+        if not addr:
+            addr = "unknown_email@example.com"
+        if not author:
+            author = addr
 
-		print """
+        print(
+            """
   <entry>
     <title>%(title)s</title>
     <author>
@@ -2071,123 +2317,151 @@
     <link rel="alternate" href="%(link)s"/>
     <summary>%(desc)s</summary>
     <content type="xhtml"><div xmlns="http://www.w3.org/1999/xhtml"><p>
-	   	""" % {
-			'title': escape(title),
-			'author': author,
-			'email': addr,
-			'url': config.myurl + '/' + config.myreponame,
-			'pdate': pdate,
-			'myrname': config.myreponame,
-			'hash': p.hash,
-			'pname': escape(p.name),
-			'link': link,
-			'desc': escape(p.name),
-		}
-
-                # TODO: allow to get plain text, not HTML?
-		print escape(p.name) + '<br/>'
-		if p.comment:
-			print '<br/>'
-			print escape(p.comment).replace('\n', '<br/>\n')
-			print '<br/>'
-		print '<br/>'
-		changed = p.adds + p.removes + p.modifies.keys() + \
-				p.moves.keys() + p.diradds + p.dirremoves + \
-				p.replaces.keys()
-		for i in changed: # TODO: link to the file 
-			print '<code>%s</code><br/>' % i
-		print '</p></div>'
-		print '</content></entry>'
-	print '</feed>'
+	   	"""
+            % {
+                "title": xmlescape(title),
+                "author": author,
+                "email": addr,
+                "url": config.myurl + "/" + config.myreponame,
+                "pdate": pdate,
+                "myrname": config.myreponame,
+                "hash": p.hash,
+                "pname": xmlescape(p.name),
+                "link": link,
+                "desc": xmlescape(p.name),
+            }
+        )
+
+        # TODO: allow to get plain text, not HTML?
+        print(xmlescape(p.name) + "<br/>")
+        if p.comment:
+            print("<br/>")
+            print(xmlescape(p.comment).replace("\n", "<br/>\n"))
+            print("<br/>")
+        print("<br/>")
+        changed = (
+            p.adds
+            + p.removes
+            + list(p.modifies.keys())
+            + list(p.moves.keys())
+            + p.diradds
+            + p.dirremoves
+            + list(p.replaces.keys())
+        )
+        for i in changed:  # TODO: link to the file
+            print("<code>%s</code><br/>" % i)
+        print("</p></div>")
+        print("</content></entry>")
+    print("</feed>")
+
 
 def do_rss():
-	print "Content-type: text/xml; charset=utf-8\n"
-	print '<?xml version="1.0" encoding="utf-8"?>'
-	print """
+    print("Content-type: text/xml; charset=utf-8\n")
+    print('<?xml version="1.0" encoding="utf-8"?>')
+    print(
+        """
 <rss version="2.0" xmlns:content="http://purl.org/rss/1.0/modules/content/">
 <channel>
  <title>%(reponame)s</title>
   <link>%(url)s</link>
   <description>%(desc)s</description>
   <language>en</language>
-  	""" % {
-		'reponame': config.reponame,
-		'url': config.myurl + '/' + config.myreponame,
-		'desc': escape(config.repodesc),
-	}
-
-	ps = get_last_patches(20)
-	for p in ps:
-		title = time.strftime('%d %b %H:%M', time.localtime(p.date))
-		title += ' - ' + p.name
-		pdate = time.strftime("%a, %d %b %Y %H:%M:%S +0000",
-				time.localtime(p.date))
-		link = '%s/%s;a=commit;h=%s' % (config.myurl,
-				config.myreponame, p.hash)
-
-		# the author field is tricky because the standard requires it
-		# has an email address; so we need to check that and lie
-		# otherwise; there's more info at
-		# http://feedvalidator.org/docs/error/InvalidContact.html
-		if "@" in p.author:
-			author = p.author
-		else:
-			author = "%s &lt;unknown@email&gt;" % p.author
+  	"""
+        % {
+            "reponame": config.reponame,
+            "url": config.myurl + "/" + config.myreponame,
+            "desc": xmlescape(config.repodesc),
+        }
+    )
+
+    ps = get_last_patches(20)
+    for p in ps:
+        title = time.strftime("%d %b %H:%M", time.localtime(p.date))
+        title += " - " + p.name
+        pdate = time.strftime(
+            "%a, %d %b %Y %H:%M:%S +0000", time.localtime(p.date)
+        )
+        link = "%s/%s;a=commit;h=%s" % (
+            config.myurl,
+            config.myreponame,
+            p.hash,
+        )
+
+        # the author field is tricky because the standard requires it
+        # has an email address; so we need to check that and lie
+        # otherwise; there's more info at
+        # http://feedvalidator.org/docs/error/InvalidContact.html
+        if "@" in p.author:
+            author = p.author
+        else:
+            author = "%s &lt;unknown@email&gt;" % p.author
 
-		print """
+        print(
+            """
   <item>
     <title>%(title)s</title>
     <author>%(author)s</author>
     <pubDate>%(pdate)s</pubDate>
     <link>%(link)s</link>
     <description>%(desc)s</description>
-	   	""" % {
-			'title': escape(title),
-			'author': author,
-			'pdate': pdate,
-			'link': link,
-			'desc': escape(p.name),
-		}
-		print '    <content:encoded><![CDATA['
-		print escape(p.name) + '<br/>'
-		if p.comment:
-			print '<br/>'
-			print escape(p.comment).replace('\n', '<br/>\n')
-			print '<br/>'
-		print '<br/>'
-		changed = p.adds + p.removes + p.modifies.keys() + \
-				p.moves.keys() + p.diradds + p.dirremoves + \
-				p.replaces.keys()
-		for i in changed:
-			print '%s<br/>' % i
-		print ']]>'
-		print '</content:encoded></item>'
+	   	"""
+            % {
+                "title": xmlescape(title),
+                "author": author,
+                "pdate": pdate,
+                "link": link,
+                "desc": xmlescape(p.name),
+            }
+        )
+        print("    <content:encoded><![CDATA[")
+        print(xmlescape(p.name) + "<br/>")
+        if p.comment:
+            print("<br/>")
+            print(xmlescape(p.comment).replace("\n", "<br/>\n"))
+            print("<br/>")
+        print("<br/>")
+        changed = (
+            p.adds
+            + p.removes
+            + list(p.modifies.keys())
+            + list(p.moves.keys())
+            + p.diradds
+            + p.dirremoves
+            + list(p.replaces.keys())
+        )
+        for i in changed:
+            print("%s<br/>" % i)
+        print("]]>")
+        print("</content:encoded></item>")
 
-	print '</channel></rss>'
+    print("</channel></rss>")
 
 
 def do_search(s):
-	print_header()
-	print_navbar()
-	ps = get_last_patches(config.searchlimit)
-
-	print '<div class="title">Search last %d commits for "%s"</div>' \
-			% (config.searchlimit, escape(s))
-	print '<table cellspacing="0">'
-
-	alt = True
-	for p in ps:
-		match = p.matches(s)
-		if not match:
-			continue
-
-		if alt:
-			print '<tr class="dark">'
-		else:
-			print '<tr class="light">'
-		alt = not alt
+    print_header()
+    print_navbar()
+    ps = get_last_patches(config.searchlimit)
+
+    print(
+        '<div class="title">Search last %d commits for "%s"</div>'
+        % (config.searchlimit, xmlescape(s))
+    )
+    print('<table cellspacing="0">')
+
+    alt = True
+    for p in ps:
+        match = p.matches(s)
+        if not match:
+            continue
+
+        if alt:
+            print('<tr class="dark">')
+        else:
+            print('<tr class="light">')
+        alt = not alt
 
-		print """
+        print(
+            """
   <td><i>%(age)s</i></td>
   <td>%(author)s</td>
   <td>
@@ -2200,35 +2474,41 @@
     <a href="%(myrname)s;a=commit;h=%(hash)s">commit</a> |
     <a href="%(myrname)s;a=commitdiff;h=%(hash)s">commitdiff</a>
   </td>
-		""" % {
-			'age': how_old(p.local_date),
-			'author': gen_authorlink(p.author, shorten_str(p.shortauthor, 26)),
-			'myrname': config.myreponame,
-			'hash': p.hash,
-			'name': escape(shorten_str(p.name)),
-			'fullname': escape(p.name),
-			'match': highlight(s, shorten_str(match)),
-		}
-		print "</tr>"
+		"""
+            % {
+                "age": how_old(p.local_date),
+                "author": gen_authorlink(
+                    p.author, shorten_str(p.shortauthor, 26)
+                ),
+                "myrname": config.myreponame,
+                "hash": p.hash,
+                "name": xmlescape(shorten_str(p.name)),
+                "fullname": xmlescape(p.name),
+                "match": highlight(s, shorten_str(match)),
+            }
+        )
+        print("</tr>")
 
-	print '</table>'
-	print_footer()
+    print("</table>")
+    print_footer()
 
 
 def do_die():
-	print_header()
-	print "<p><font color=red>Error! Malformed query</font></p>"
-	print_footer()
+    print_header()
+    print("<p><font color=red>Error! Malformed query</font></p>")
+    print_footer()
 
 
 def do_listrepos():
-	import config as all_configs
-	expand_multi_config(all_configs)
+    import config as all_configs
+
+    expand_multi_config(all_configs)
 
-	# the header here is special since we don't have a repo
-	print "Content-type: text/html; charset=utf-8\n"
-	print '<?xml version="1.0" encoding="utf-8"?>'
-	print """
+    # the header here is special since we don't have a repo
+    print("Content-type: text/html; charset=utf-8\n")
+    print('<?xml version="1.0" encoding="utf-8"?>')
+    print(
+        """
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 		"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-US" lang="en-US">
@@ -2257,29 +2537,34 @@
 <th>Description</th>
 <th></th>
 </tr>
-	""" % {
-		'myname': config.myname,
-		'css': config.cssfile,
-		'fav': config.darcsfav,
-		'logo': config.darcslogo,
-		'summary': config.summary
-	}
-
-	# some python magic
-	alt = True
-	for conf in dir(all_configs):
-		if conf.startswith('__'):
-			continue
-		c = all_configs.__getattribute__(conf)
-		if 'reponame' not in dir(c):
-			continue
-		name = escape(c.reponame)
-		desc = escape(c.repodesc)
-
-		if alt: print '<tr class="dark">'
-		else: print '<tr class="light">'
-		alt = not alt
-		print """
+	"""
+        % {
+            "myname": config.myname,
+            "css": config.cssfile,
+            "fav": config.darcsfav,
+            "logo": config.darcslogo,
+            "summary": config.summary,
+        }
+    )
+
+    # some python magic
+    alt = True
+    for conf in dir(all_configs):
+        if conf.startswith("__"):
+            continue
+        c = all_configs.__getattribute__(conf)
+        if "reponame" not in dir(c):
+            continue
+        name = xmlescape(c.reponame)
+        desc = xmlescape(c.repodesc)
+
+        if alt:
+            print('<tr class="dark">')
+        else:
+            print('<tr class="light">')
+        alt = not alt
+        print(
+            """
 <td><a class="list" href="%(myname)s?r=%(name)s;a=summary">%(dname)s</a></td>
 <td>%(desc)s</td>
 <td class="link"><a href="%(myname)s?r=%(name)s;a=summary">summary</a> |
